<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CHANGE_INFOType' => '\\StructType\\CHANGE_INFOType',
            'LOV_VALUEType' => '\\StructType\\LOV_VALUEType',
            'ATTRIBUTESTYPE' => '\\StructType\\ATTRIBUTESTYPE',
            'AmountType' => '\\StructType\\AmountType',
            'PARTINFO' => '\\StructType\\PARTINFO',
            'CUSTOMER' => '\\StructType\\CUSTOMER',
            'REQUEST' => '\\StructType\\REQUEST',
            'REQUEST_HEADERType' => '\\StructType\\REQUEST_HEADERType',
            'REQUEST_RETURNType' => '\\StructType\\REQUEST_RETURNType',
            'REQUEST_ERRORType' => '\\StructType\\REQUEST_ERRORType',
            'REQUEST_INFOType' => '\\StructType\\REQUEST_INFOType',
            'base64Binary' => '\\StructType\\Base64Binary',
            'hexBinary' => '\\StructType\\HexBinary',
            'INVOICE' => '\\StructType\\INVOICE',
            'HEADER' => '\\StructType\\HEADER',
            'ENVELOPE' => '\\StructType\\ENVELOPE',
            'LoginRequest' => '\\StructType\\LoginRequest',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'LogoutRequest' => '\\StructType\\LogoutRequest',
            'LogoutResponse' => '\\StructType\\LogoutResponse',
            'USERCONTENT' => '\\StructType\\USERCONTENT',
            'UserRequest' => '\\StructType\\UserRequest',
            'UserResponse' => '\\StructType\\UserResponse',
            'SendInvoiceRequest' => '\\StructType\\SendInvoiceRequest',
            'SENDER' => '\\StructType\\SENDER',
            'RECEIVER' => '\\StructType\\RECEIVER',
            'SendInvoiceResponse' => '\\StructType\\SendInvoiceResponse',
            'GetInvoiceRequest' => '\\StructType\\GetInvoiceRequest',
            'INVOICE_SEARCH_KEY' => '\\StructType\\INVOICE_SEARCH_KEY',
            'GetInvoiceResponse' => '\\StructType\\GetInvoiceResponse',
            'MarkInvoiceRequest' => '\\StructType\\MarkInvoiceRequest',
            'MARK' => '\\StructType\\MARK',
            'MarkInvoiceResponse' => '\\StructType\\MarkInvoiceResponse',
            'PrepareInvoiceResponseRequest' => '\\StructType\\PrepareInvoiceResponseRequest',
            'PrepareInvoiceResponseResponse' => '\\StructType\\PrepareInvoiceResponseResponse',
            'SendInvoiceResponseRequest' => '\\StructType\\SendInvoiceResponseRequest',
            'SendInvoiceResponseResponse' => '\\StructType\\SendInvoiceResponseResponse',
            'SendInvoiceResponseWithServerSignRequest' => '\\StructType\\SendInvoiceResponseWithServerSignRequest',
            'SendInvoiceResponseWithServerSignResponse' => '\\StructType\\SendInvoiceResponseWithServerSignResponse',
            'GetUserListRequest' => '\\StructType\\GetUserListRequest',
            'GetUserListResponse' => '\\StructType\\GetUserListResponse',
            'GetUserListBinaryRequest' => '\\StructType\\GetUserListBinaryRequest',
            'GetUserListBinaryResponse' => '\\StructType\\GetUserListBinaryResponse',
            'CheckUserRequest' => '\\StructType\\CheckUserRequest',
            'CheckUserResponse' => '\\StructType\\CheckUserResponse',
            'GIBUSER' => '\\StructType\\GIBUSER',
            'GetInvoiceStatusRequest' => '\\StructType\\GetInvoiceStatusRequest',
            'GetInvoiceStatusResponse' => '\\StructType\\GetInvoiceStatusResponse',
            'INVOICE_STATUS' => '\\StructType\\INVOICE_STATUS',
            'GetInvoiceStatusAllRequest' => '\\StructType\\GetInvoiceStatusAllRequest',
            'GetInvoiceStatusAllResponse' => '\\StructType\\GetInvoiceStatusAllResponse',
            'CancelDraftInvoiceRequest' => '\\StructType\\CancelDraftInvoiceRequest',
            'CancelDraftInvoiceResponse' => '\\StructType\\CancelDraftInvoiceResponse',
            'LoadInvoiceRequest' => '\\StructType\\LoadInvoiceRequest',
            'LoadInvoiceResponse' => '\\StructType\\LoadInvoiceResponse',
            'GetEnvelopeRequest' => '\\StructType\\GetEnvelopeRequest',
            'ENVELOPE_SEARCH_KEY' => '\\StructType\\ENVELOPE_SEARCH_KEY',
            'ELEMENT' => '\\StructType\\ELEMENT',
            'GetEnvelopeResponse' => '\\StructType\\GetEnvelopeResponse',
            'MarkEnvelopeRequest' => '\\StructType\\MarkEnvelopeRequest',
            'MarkEnvelopeResponse' => '\\StructType\\MarkEnvelopeResponse',
            'GetEnvelopeStatusRequest' => '\\StructType\\GetEnvelopeStatusRequest',
            'GetEnvelopeStatusResponse' => '\\StructType\\GetEnvelopeStatusResponse',
            'GetInvoiceWithTypeRequest' => '\\StructType\\GetInvoiceWithTypeRequest',
            'GetInvoiceWithTypeResponse' => '\\StructType\\GetInvoiceWithTypeResponse',
            'GetInvoiceCountRequest' => '\\StructType\\GetInvoiceCountRequest',
            'GetInvoiceCountResponse' => '\\StructType\\GetInvoiceCountResponse',
            'getAppRespRequestType' => '\\StructType\\GetAppRespRequestType',
            'getAppRespResponseType' => '\\StructType\\GetAppRespResponseType',
        );
    }
}
