<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckUserResponse StructType
 * Meta information extracted from the WSDL
 * - type: CheckUserResponse
 * @subpackage Structs
 */
class CheckUserResponse extends AbstractStructBase
{
    /**
     * The USER
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GIBUSER[]
     */
    public $USER;
    /**
     * Constructor method for CheckUserResponse
     * @uses CheckUserResponse::setUSER()
     * @param \StructType\GIBUSER[] $uSER
     */
    public function __construct(array $uSER = array())
    {
        $this
            ->setUSER($uSER);
    }
    /**
     * Get USER value
     * @return \StructType\GIBUSER[]|null
     */
    public function getUSER()
    {
        return $this->USER;
    }
    /**
     * This method is responsible for validating the values passed to the setUSER method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUSER method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUSERForArrayConstraintsFromSetUSER(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $checkUserResponseUSERItem) {
            // validation for constraint: itemType
            if (!$checkUserResponseUSERItem instanceof \StructType\GIBUSER) {
                $invalidValues[] = is_object($checkUserResponseUSERItem) ? get_class($checkUserResponseUSERItem) : sprintf('%s(%s)', gettype($checkUserResponseUSERItem), var_export($checkUserResponseUSERItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The USER property can only contain items of type \StructType\GIBUSER, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set USER value
     * @throws \InvalidArgumentException
     * @param \StructType\GIBUSER[] $uSER
     * @return \StructType\CheckUserResponse
     */
    public function setUSER(array $uSER = array())
    {
        // validation for constraint: array
        if ('' !== ($uSERArrayErrorMessage = self::validateUSERForArrayConstraintsFromSetUSER($uSER))) {
            throw new \InvalidArgumentException($uSERArrayErrorMessage, __LINE__);
        }
        $this->USER = $uSER;
        return $this;
    }
    /**
     * Add item to USER value
     * @throws \InvalidArgumentException
     * @param \StructType\GIBUSER $item
     * @return \StructType\CheckUserResponse
     */
    public function addToUSER(\StructType\GIBUSER $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GIBUSER) {
            throw new \InvalidArgumentException(sprintf('The USER property can only contain items of type \StructType\GIBUSER, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->USER[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CheckUserResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
