<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetEnvelopeStatusResponse StructType
 * Meta information extracted from the WSDL
 * - type: GetEnvelopeStatusResponse
 * @subpackage Structs
 */
class GetEnvelopeStatusResponse extends AbstractStructBase
{
    /**
     * The ENVELOPE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\ENVELOPE[]
     */
    public $ENVELOPE;
    /**
     * Constructor method for GetEnvelopeStatusResponse
     * @uses GetEnvelopeStatusResponse::setENVELOPE()
     * @param \StructType\ENVELOPE[] $eNVELOPE
     */
    public function __construct(array $eNVELOPE = array())
    {
        $this
            ->setENVELOPE($eNVELOPE);
    }
    /**
     * Get ENVELOPE value
     * @return \StructType\ENVELOPE[]
     */
    public function getENVELOPE()
    {
        return $this->ENVELOPE;
    }
    /**
     * This method is responsible for validating the values passed to the setENVELOPE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setENVELOPE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateENVELOPEForArrayConstraintsFromSetENVELOPE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getEnvelopeStatusResponseENVELOPEItem) {
            // validation for constraint: itemType
            if (!$getEnvelopeStatusResponseENVELOPEItem instanceof \StructType\ENVELOPE) {
                $invalidValues[] = is_object($getEnvelopeStatusResponseENVELOPEItem) ? get_class($getEnvelopeStatusResponseENVELOPEItem) : sprintf('%s(%s)', gettype($getEnvelopeStatusResponseENVELOPEItem), var_export($getEnvelopeStatusResponseENVELOPEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ENVELOPE property can only contain items of type \StructType\ENVELOPE, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ENVELOPE value
     * @throws \InvalidArgumentException
     * @param \StructType\ENVELOPE[] $eNVELOPE
     * @return \StructType\GetEnvelopeStatusResponse
     */
    public function setENVELOPE(array $eNVELOPE = array())
    {
        // validation for constraint: array
        if ('' !== ($eNVELOPEArrayErrorMessage = self::validateENVELOPEForArrayConstraintsFromSetENVELOPE($eNVELOPE))) {
            throw new \InvalidArgumentException($eNVELOPEArrayErrorMessage, __LINE__);
        }
        $this->ENVELOPE = $eNVELOPE;
        return $this;
    }
    /**
     * Add item to ENVELOPE value
     * @throws \InvalidArgumentException
     * @param \StructType\ENVELOPE $item
     * @return \StructType\GetEnvelopeStatusResponse
     */
    public function addToENVELOPE(\StructType\ENVELOPE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ENVELOPE) {
            throw new \InvalidArgumentException(sprintf('The ENVELOPE property can only contain items of type \StructType\ENVELOPE, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ENVELOPE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetEnvelopeStatusResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
