<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetInvoiceStatusAllRequest StructType
 * Meta information extracted from the WSDL
 * - type: GetInvoiceStatusAllRequest
 * @subpackage Structs
 */
class GetInvoiceStatusAllRequest extends REQUEST
{
    /**
     * The UUID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var string[]
     */
    public $UUID;
    /**
     * Constructor method for GetInvoiceStatusAllRequest
     * @uses GetInvoiceStatusAllRequest::setUUID()
     * @param string[] $uUID
     */
    public function __construct(array $uUID = array())
    {
        $this
            ->setUUID($uUID);
    }
    /**
     * Get UUID value
     * @return string[]
     */
    public function getUUID()
    {
        return $this->UUID;
    }
    /**
     * This method is responsible for validating the values passed to the setUUID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUUID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUUIDForArrayConstraintsFromSetUUID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getInvoiceStatusAllRequestUUIDItem) {
            // validation for constraint: itemType
            if (!is_string($getInvoiceStatusAllRequestUUIDItem)) {
                $invalidValues[] = is_object($getInvoiceStatusAllRequestUUIDItem) ? get_class($getInvoiceStatusAllRequestUUIDItem) : sprintf('%s(%s)', gettype($getInvoiceStatusAllRequestUUIDItem), var_export($getInvoiceStatusAllRequestUUIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UUID property can only contain items of type token, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UUID value
     * @throws \InvalidArgumentException
     * @param string[] $uUID
     * @return \StructType\GetInvoiceStatusAllRequest
     */
    public function setUUID(array $uUID = array())
    {
        // validation for constraint: array
        if ('' !== ($uUIDArrayErrorMessage = self::validateUUIDForArrayConstraintsFromSetUUID($uUID))) {
            throw new \InvalidArgumentException($uUIDArrayErrorMessage, __LINE__);
        }
        $this->UUID = $uUID;
        return $this;
    }
    /**
     * Add item to UUID value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\GetInvoiceStatusAllRequest
     */
    public function addToUUID($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The UUID property can only contain items of type token, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UUID[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetInvoiceStatusAllRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
