<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUserListBinaryResponse StructType
 * Meta information extracted from the WSDL
 * - type: GetUserListBinaryResponse
 * @subpackage Structs
 */
class GetUserListBinaryResponse extends AbstractStructBase
{
    /**
     * The CONTENT
     * Meta information extracted from the WSDL
     * - choice: CONTENT
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Base64Binary
     */
    public $CONTENT;
    /**
     * Constructor method for GetUserListBinaryResponse
     * @uses GetUserListBinaryResponse::setCONTENT()
     * @param \StructType\Base64Binary $cONTENT
     */
    public function __construct(\StructType\Base64Binary $cONTENT = null)
    {
        $this
            ->setCONTENT($cONTENT);
    }
    /**
     * Get CONTENT value
     * @return \StructType\Base64Binary|null
     */
    public function getCONTENT()
    {
        return isset($this->CONTENT) ? $this->CONTENT : null;
    }
    /**
     * This method is responsible for validating the value passed to the setCONTENT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCONTENT method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCONTENTForChoiceConstraintsFromSetCONTENT($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property CONTENT can\'t be set as the property %s is already set. Only one property must be set among these properties: CONTENT, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set CONTENT value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary $cONTENT
     * @return \StructType\GetUserListBinaryResponse
     */
    public function setCONTENT(\StructType\Base64Binary $cONTENT = null)
    {
        // validation for constraint: choice(CONTENT)
        if ('' !== ($cONTENTChoiceErrorMessage = self::validateCONTENTForChoiceConstraintsFromSetCONTENT($cONTENT))) {
            throw new \InvalidArgumentException($cONTENTChoiceErrorMessage, __LINE__);
        }
        if (is_null($cONTENT) || (is_array($cONTENT) && empty($cONTENT))) {
            unset($this->CONTENT);
        } else {
            $this->CONTENT = $cONTENT;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUserListBinaryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
