<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for INVOICE_SEARCH_KEY StructType
 * @subpackage Structs
 */
class INVOICE_SEARCH_KEY extends AbstractStructBase
{
    /**
     * The LIMIT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $LIMIT;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ID;
    /**
     * The UUID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UUID;
    /**
     * The FROM
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FROM;
    /**
     * The TO
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TO;
    /**
     * The DATE_TYPE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DATE_TYPE;
    /**
     * The START_DATE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $START_DATE;
    /**
     * The END_DATE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $END_DATE;
    /**
     * The READ_INCLUDED
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $READ_INCLUDED;
    /**
     * The DIRECTION
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DIRECTION;
    /**
     * The SENDER
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $SENDER;
    /**
     * The RECEIVER
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RECEIVER;
    /**
     * The DRAFT_FLAG
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DRAFT_FLAG;
    /**
     * The EXTERNAL_ID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EXTERNAL_ID;
    /**
     * The TYPE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TYPE;
    /**
     * The PAYABLE_AMOUNT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AmountType
     */
    public $PAYABLE_AMOUNT;
    /**
     * Constructor method for INVOICE_SEARCH_KEY
     * @uses INVOICE_SEARCH_KEY::setLIMIT()
     * @uses INVOICE_SEARCH_KEY::setID()
     * @uses INVOICE_SEARCH_KEY::setUUID()
     * @uses INVOICE_SEARCH_KEY::setFROM()
     * @uses INVOICE_SEARCH_KEY::setTO()
     * @uses INVOICE_SEARCH_KEY::setDATE_TYPE()
     * @uses INVOICE_SEARCH_KEY::setSTART_DATE()
     * @uses INVOICE_SEARCH_KEY::setEND_DATE()
     * @uses INVOICE_SEARCH_KEY::setREAD_INCLUDED()
     * @uses INVOICE_SEARCH_KEY::setDIRECTION()
     * @uses INVOICE_SEARCH_KEY::setSENDER()
     * @uses INVOICE_SEARCH_KEY::setRECEIVER()
     * @uses INVOICE_SEARCH_KEY::setDRAFT_FLAG()
     * @uses INVOICE_SEARCH_KEY::setEXTERNAL_ID()
     * @uses INVOICE_SEARCH_KEY::setTYPE()
     * @uses INVOICE_SEARCH_KEY::setPAYABLE_AMOUNT()
     * @param int $lIMIT
     * @param string $iD
     * @param string $uUID
     * @param string $fROM
     * @param string $tO
     * @param string $dATE_TYPE
     * @param string $sTART_DATE
     * @param string $eND_DATE
     * @param bool $rEAD_INCLUDED
     * @param string $dIRECTION
     * @param string $sENDER
     * @param string $rECEIVER
     * @param string $dRAFT_FLAG
     * @param string $eXTERNAL_ID
     * @param string $tYPE
     * @param \StructType\AmountType $pAYABLE_AMOUNT
     */
    public function __construct($lIMIT = null, $iD = null, $uUID = null, $fROM = null, $tO = null, $dATE_TYPE = null, $sTART_DATE = null, $eND_DATE = null, $rEAD_INCLUDED = null, $dIRECTION = null, $sENDER = null, $rECEIVER = null, $dRAFT_FLAG = null, $eXTERNAL_ID = null, $tYPE = null, \StructType\AmountType $pAYABLE_AMOUNT = null)
    {
        $this
            ->setLIMIT($lIMIT)
            ->setID($iD)
            ->setUUID($uUID)
            ->setFROM($fROM)
            ->setTO($tO)
            ->setDATE_TYPE($dATE_TYPE)
            ->setSTART_DATE($sTART_DATE)
            ->setEND_DATE($eND_DATE)
            ->setREAD_INCLUDED($rEAD_INCLUDED)
            ->setDIRECTION($dIRECTION)
            ->setSENDER($sENDER)
            ->setRECEIVER($rECEIVER)
            ->setDRAFT_FLAG($dRAFT_FLAG)
            ->setEXTERNAL_ID($eXTERNAL_ID)
            ->setTYPE($tYPE)
            ->setPAYABLE_AMOUNT($pAYABLE_AMOUNT);
    }
    /**
     * Get LIMIT value
     * @return int|null
     */
    public function getLIMIT()
    {
        return $this->LIMIT;
    }
    /**
     * Set LIMIT value
     * @param int $lIMIT
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setLIMIT($lIMIT = null)
    {
        // validation for constraint: int
        if (!is_null($lIMIT) && !(is_int($lIMIT) || ctype_digit($lIMIT))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lIMIT, true), gettype($lIMIT)), __LINE__);
        }
        $this->LIMIT = $lIMIT;
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get UUID value
     * @return string|null
     */
    public function getUUID()
    {
        return $this->UUID;
    }
    /**
     * Set UUID value
     * @param string $uUID
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setUUID($uUID = null)
    {
        // validation for constraint: string
        if (!is_null($uUID) && !is_string($uUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uUID, true), gettype($uUID)), __LINE__);
        }
        $this->UUID = $uUID;
        return $this;
    }
    /**
     * Get FROM value
     * @return string|null
     */
    public function getFROM()
    {
        return $this->FROM;
    }
    /**
     * Set FROM value
     * @param string $fROM
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setFROM($fROM = null)
    {
        // validation for constraint: string
        if (!is_null($fROM) && !is_string($fROM)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fROM, true), gettype($fROM)), __LINE__);
        }
        $this->FROM = $fROM;
        return $this;
    }
    /**
     * Get TO value
     * @return string|null
     */
    public function getTO()
    {
        return $this->TO;
    }
    /**
     * Set TO value
     * @param string $tO
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setTO($tO = null)
    {
        // validation for constraint: string
        if (!is_null($tO) && !is_string($tO)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tO, true), gettype($tO)), __LINE__);
        }
        $this->TO = $tO;
        return $this;
    }
    /**
     * Get DATE_TYPE value
     * @return string|null
     */
    public function getDATE_TYPE()
    {
        return $this->DATE_TYPE;
    }
    /**
     * Set DATE_TYPE value
     * @uses \EnumType\DATE_TYPE::valueIsValid()
     * @uses \EnumType\DATE_TYPE::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $dATE_TYPE
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setDATE_TYPE($dATE_TYPE = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DATE_TYPE::valueIsValid($dATE_TYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DATE_TYPE', is_array($dATE_TYPE) ? implode(', ', $dATE_TYPE) : var_export($dATE_TYPE, true), implode(', ', \EnumType\DATE_TYPE::getValidValues())), __LINE__);
        }
        $this->DATE_TYPE = $dATE_TYPE;
        return $this;
    }
    /**
     * Get START_DATE value
     * @return string|null
     */
    public function getSTART_DATE()
    {
        return $this->START_DATE;
    }
    /**
     * Set START_DATE value
     * @param string $sTART_DATE
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setSTART_DATE($sTART_DATE = null)
    {
        // validation for constraint: string
        if (!is_null($sTART_DATE) && !is_string($sTART_DATE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sTART_DATE, true), gettype($sTART_DATE)), __LINE__);
        }
        $this->START_DATE = $sTART_DATE;
        return $this;
    }
    /**
     * Get END_DATE value
     * @return string|null
     */
    public function getEND_DATE()
    {
        return $this->END_DATE;
    }
    /**
     * Set END_DATE value
     * @param string $eND_DATE
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setEND_DATE($eND_DATE = null)
    {
        // validation for constraint: string
        if (!is_null($eND_DATE) && !is_string($eND_DATE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eND_DATE, true), gettype($eND_DATE)), __LINE__);
        }
        $this->END_DATE = $eND_DATE;
        return $this;
    }
    /**
     * Get READ_INCLUDED value
     * @return bool|null
     */
    public function getREAD_INCLUDED()
    {
        return $this->READ_INCLUDED;
    }
    /**
     * Set READ_INCLUDED value
     * @param bool $rEAD_INCLUDED
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setREAD_INCLUDED($rEAD_INCLUDED = null)
    {
        // validation for constraint: boolean
        if (!is_null($rEAD_INCLUDED) && !is_bool($rEAD_INCLUDED)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($rEAD_INCLUDED, true), gettype($rEAD_INCLUDED)), __LINE__);
        }
        $this->READ_INCLUDED = $rEAD_INCLUDED;
        return $this;
    }
    /**
     * Get DIRECTION value
     * @return string|null
     */
    public function getDIRECTION()
    {
        return $this->DIRECTION;
    }
    /**
     * Set DIRECTION value
     * @param string $dIRECTION
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setDIRECTION($dIRECTION = null)
    {
        // validation for constraint: string
        if (!is_null($dIRECTION) && !is_string($dIRECTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dIRECTION, true), gettype($dIRECTION)), __LINE__);
        }
        $this->DIRECTION = $dIRECTION;
        return $this;
    }
    /**
     * Get SENDER value
     * @return string|null
     */
    public function getSENDER()
    {
        return $this->SENDER;
    }
    /**
     * Set SENDER value
     * @param string $sENDER
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setSENDER($sENDER = null)
    {
        // validation for constraint: string
        if (!is_null($sENDER) && !is_string($sENDER)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sENDER, true), gettype($sENDER)), __LINE__);
        }
        $this->SENDER = $sENDER;
        return $this;
    }
    /**
     * Get RECEIVER value
     * @return string|null
     */
    public function getRECEIVER()
    {
        return $this->RECEIVER;
    }
    /**
     * Set RECEIVER value
     * @param string $rECEIVER
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setRECEIVER($rECEIVER = null)
    {
        // validation for constraint: string
        if (!is_null($rECEIVER) && !is_string($rECEIVER)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rECEIVER, true), gettype($rECEIVER)), __LINE__);
        }
        $this->RECEIVER = $rECEIVER;
        return $this;
    }
    /**
     * Get DRAFT_FLAG value
     * @return string|null
     */
    public function getDRAFT_FLAG()
    {
        return $this->DRAFT_FLAG;
    }
    /**
     * Set DRAFT_FLAG value
     * @param string $dRAFT_FLAG
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setDRAFT_FLAG($dRAFT_FLAG = null)
    {
        // validation for constraint: string
        if (!is_null($dRAFT_FLAG) && !is_string($dRAFT_FLAG)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dRAFT_FLAG, true), gettype($dRAFT_FLAG)), __LINE__);
        }
        $this->DRAFT_FLAG = $dRAFT_FLAG;
        return $this;
    }
    /**
     * Get EXTERNAL_ID value
     * @return string|null
     */
    public function getEXTERNAL_ID()
    {
        return $this->EXTERNAL_ID;
    }
    /**
     * Set EXTERNAL_ID value
     * @param string $eXTERNAL_ID
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setEXTERNAL_ID($eXTERNAL_ID = null)
    {
        // validation for constraint: string
        if (!is_null($eXTERNAL_ID) && !is_string($eXTERNAL_ID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eXTERNAL_ID, true), gettype($eXTERNAL_ID)), __LINE__);
        }
        $this->EXTERNAL_ID = $eXTERNAL_ID;
        return $this;
    }
    /**
     * Get TYPE value
     * @return string|null
     */
    public function getTYPE()
    {
        return $this->TYPE;
    }
    /**
     * Set TYPE value
     * @param string $tYPE
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setTYPE($tYPE = null)
    {
        // validation for constraint: string
        if (!is_null($tYPE) && !is_string($tYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tYPE, true), gettype($tYPE)), __LINE__);
        }
        $this->TYPE = $tYPE;
        return $this;
    }
    /**
     * Get PAYABLE_AMOUNT value
     * @return \StructType\AmountType|null
     */
    public function getPAYABLE_AMOUNT()
    {
        return $this->PAYABLE_AMOUNT;
    }
    /**
     * Set PAYABLE_AMOUNT value
     * @param \StructType\AmountType $pAYABLE_AMOUNT
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public function setPAYABLE_AMOUNT(\StructType\AmountType $pAYABLE_AMOUNT = null)
    {
        $this->PAYABLE_AMOUNT = $pAYABLE_AMOUNT;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\INVOICE_SEARCH_KEY
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
