<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for INVOICE_STATUS StructType
 * @subpackage Structs
 */
class INVOICE_STATUS extends INVOICE
{
    /**
     * The STATUS
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $STATUS;
    /**
     * The STATUS_DESCRIPTION
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $STATUS_DESCRIPTION;
    /**
     * The STATUS_CODE
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $STATUS_CODE;
    /**
     * The GIB_STATUS_CODE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $GIB_STATUS_CODE;
    /**
     * The GIB_STATUS_DESCRIPTION
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GIB_STATUS_DESCRIPTION;
    /**
     * The RESPONSE_CODE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RESPONSE_CODE;
    /**
     * The RESPONSE_DESCRIPTION
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RESPONSE_DESCRIPTION;
    /**
     * The CDATE
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CDATE;
    /**
     * The ENVELOPE_IDENTIFIER
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ENVELOPE_IDENTIFIER;
    /**
     * The GTB_REFNO
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GTB_REFNO;
    /**
     * The GTB_GCB_TESCILNO
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GTB_GCB_TESCILNO;
    /**
     * The GTB_FIILI_IHRACAT_TARIHI
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GTB_FIILI_IHRACAT_TARIHI;
    /**
     * Constructor method for INVOICE_STATUS
     * @uses INVOICE_STATUS::setSTATUS()
     * @uses INVOICE_STATUS::setSTATUS_DESCRIPTION()
     * @uses INVOICE_STATUS::setSTATUS_CODE()
     * @uses INVOICE_STATUS::setGIB_STATUS_CODE()
     * @uses INVOICE_STATUS::setGIB_STATUS_DESCRIPTION()
     * @uses INVOICE_STATUS::setRESPONSE_CODE()
     * @uses INVOICE_STATUS::setRESPONSE_DESCRIPTION()
     * @uses INVOICE_STATUS::setCDATE()
     * @uses INVOICE_STATUS::setENVELOPE_IDENTIFIER()
     * @uses INVOICE_STATUS::setGTB_REFNO()
     * @uses INVOICE_STATUS::setGTB_GCB_TESCILNO()
     * @uses INVOICE_STATUS::setGTB_FIILI_IHRACAT_TARIHI()
     * @param string $sTATUS
     * @param string $sTATUS_DESCRIPTION
     * @param string $sTATUS_CODE
     * @param int $gIB_STATUS_CODE
     * @param string $gIB_STATUS_DESCRIPTION
     * @param string $rESPONSE_CODE
     * @param string $rESPONSE_DESCRIPTION
     * @param string $cDATE
     * @param string $eNVELOPE_IDENTIFIER
     * @param string $gTB_REFNO
     * @param string $gTB_GCB_TESCILNO
     * @param string $gTB_FIILI_IHRACAT_TARIHI
     */
    public function __construct($sTATUS = null, $sTATUS_DESCRIPTION = null, $sTATUS_CODE = null, $gIB_STATUS_CODE = null, $gIB_STATUS_DESCRIPTION = null, $rESPONSE_CODE = null, $rESPONSE_DESCRIPTION = null, $cDATE = null, $eNVELOPE_IDENTIFIER = null, $gTB_REFNO = null, $gTB_GCB_TESCILNO = null, $gTB_FIILI_IHRACAT_TARIHI = null)
    {
        $this
            ->setSTATUS($sTATUS)
            ->setSTATUS_DESCRIPTION($sTATUS_DESCRIPTION)
            ->setSTATUS_CODE($sTATUS_CODE)
            ->setGIB_STATUS_CODE($gIB_STATUS_CODE)
            ->setGIB_STATUS_DESCRIPTION($gIB_STATUS_DESCRIPTION)
            ->setRESPONSE_CODE($rESPONSE_CODE)
            ->setRESPONSE_DESCRIPTION($rESPONSE_DESCRIPTION)
            ->setCDATE($cDATE)
            ->setENVELOPE_IDENTIFIER($eNVELOPE_IDENTIFIER)
            ->setGTB_REFNO($gTB_REFNO)
            ->setGTB_GCB_TESCILNO($gTB_GCB_TESCILNO)
            ->setGTB_FIILI_IHRACAT_TARIHI($gTB_FIILI_IHRACAT_TARIHI);
    }
    /**
     * Get STATUS value
     * @return string
     */
    public function getSTATUS()
    {
        return $this->STATUS;
    }
    /**
     * Set STATUS value
     * @param string $sTATUS
     * @return \StructType\INVOICE_STATUS
     */
    public function setSTATUS($sTATUS = null)
    {
        // validation for constraint: string
        if (!is_null($sTATUS) && !is_string($sTATUS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sTATUS, true), gettype($sTATUS)), __LINE__);
        }
        $this->STATUS = $sTATUS;
        return $this;
    }
    /**
     * Get STATUS_DESCRIPTION value
     * @return string
     */
    public function getSTATUS_DESCRIPTION()
    {
        return $this->STATUS_DESCRIPTION;
    }
    /**
     * Set STATUS_DESCRIPTION value
     * @param string $sTATUS_DESCRIPTION
     * @return \StructType\INVOICE_STATUS
     */
    public function setSTATUS_DESCRIPTION($sTATUS_DESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($sTATUS_DESCRIPTION) && !is_string($sTATUS_DESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sTATUS_DESCRIPTION, true), gettype($sTATUS_DESCRIPTION)), __LINE__);
        }
        $this->STATUS_DESCRIPTION = $sTATUS_DESCRIPTION;
        return $this;
    }
    /**
     * Get STATUS_CODE value
     * @return string
     */
    public function getSTATUS_CODE()
    {
        return $this->STATUS_CODE;
    }
    /**
     * Set STATUS_CODE value
     * @param string $sTATUS_CODE
     * @return \StructType\INVOICE_STATUS
     */
    public function setSTATUS_CODE($sTATUS_CODE = null)
    {
        // validation for constraint: string
        if (!is_null($sTATUS_CODE) && !is_string($sTATUS_CODE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sTATUS_CODE, true), gettype($sTATUS_CODE)), __LINE__);
        }
        $this->STATUS_CODE = $sTATUS_CODE;
        return $this;
    }
    /**
     * Get GIB_STATUS_CODE value
     * @return int|null
     */
    public function getGIB_STATUS_CODE()
    {
        return $this->GIB_STATUS_CODE;
    }
    /**
     * Set GIB_STATUS_CODE value
     * @param int $gIB_STATUS_CODE
     * @return \StructType\INVOICE_STATUS
     */
    public function setGIB_STATUS_CODE($gIB_STATUS_CODE = null)
    {
        // validation for constraint: int
        if (!is_null($gIB_STATUS_CODE) && !(is_int($gIB_STATUS_CODE) || ctype_digit($gIB_STATUS_CODE))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($gIB_STATUS_CODE, true), gettype($gIB_STATUS_CODE)), __LINE__);
        }
        $this->GIB_STATUS_CODE = $gIB_STATUS_CODE;
        return $this;
    }
    /**
     * Get GIB_STATUS_DESCRIPTION value
     * @return string|null
     */
    public function getGIB_STATUS_DESCRIPTION()
    {
        return $this->GIB_STATUS_DESCRIPTION;
    }
    /**
     * Set GIB_STATUS_DESCRIPTION value
     * @param string $gIB_STATUS_DESCRIPTION
     * @return \StructType\INVOICE_STATUS
     */
    public function setGIB_STATUS_DESCRIPTION($gIB_STATUS_DESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($gIB_STATUS_DESCRIPTION) && !is_string($gIB_STATUS_DESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gIB_STATUS_DESCRIPTION, true), gettype($gIB_STATUS_DESCRIPTION)), __LINE__);
        }
        $this->GIB_STATUS_DESCRIPTION = $gIB_STATUS_DESCRIPTION;
        return $this;
    }
    /**
     * Get RESPONSE_CODE value
     * @return string|null
     */
    public function getRESPONSE_CODE()
    {
        return $this->RESPONSE_CODE;
    }
    /**
     * Set RESPONSE_CODE value
     * @param string $rESPONSE_CODE
     * @return \StructType\INVOICE_STATUS
     */
    public function setRESPONSE_CODE($rESPONSE_CODE = null)
    {
        // validation for constraint: string
        if (!is_null($rESPONSE_CODE) && !is_string($rESPONSE_CODE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rESPONSE_CODE, true), gettype($rESPONSE_CODE)), __LINE__);
        }
        $this->RESPONSE_CODE = $rESPONSE_CODE;
        return $this;
    }
    /**
     * Get RESPONSE_DESCRIPTION value
     * @return string|null
     */
    public function getRESPONSE_DESCRIPTION()
    {
        return $this->RESPONSE_DESCRIPTION;
    }
    /**
     * Set RESPONSE_DESCRIPTION value
     * @param string $rESPONSE_DESCRIPTION
     * @return \StructType\INVOICE_STATUS
     */
    public function setRESPONSE_DESCRIPTION($rESPONSE_DESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($rESPONSE_DESCRIPTION) && !is_string($rESPONSE_DESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rESPONSE_DESCRIPTION, true), gettype($rESPONSE_DESCRIPTION)), __LINE__);
        }
        $this->RESPONSE_DESCRIPTION = $rESPONSE_DESCRIPTION;
        return $this;
    }
    /**
     * Get CDATE value
     * @return string|null
     */
    public function getCDATE()
    {
        return $this->CDATE;
    }
    /**
     * Set CDATE value
     * @param string $cDATE
     * @return \StructType\INVOICE_STATUS
     */
    public function setCDATE($cDATE = null)
    {
        // validation for constraint: string
        if (!is_null($cDATE) && !is_string($cDATE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cDATE, true), gettype($cDATE)), __LINE__);
        }
        $this->CDATE = $cDATE;
        return $this;
    }
    /**
     * Get ENVELOPE_IDENTIFIER value
     * @return string|null
     */
    public function getENVELOPE_IDENTIFIER()
    {
        return $this->ENVELOPE_IDENTIFIER;
    }
    /**
     * Set ENVELOPE_IDENTIFIER value
     * @param string $eNVELOPE_IDENTIFIER
     * @return \StructType\INVOICE_STATUS
     */
    public function setENVELOPE_IDENTIFIER($eNVELOPE_IDENTIFIER = null)
    {
        // validation for constraint: string
        if (!is_null($eNVELOPE_IDENTIFIER) && !is_string($eNVELOPE_IDENTIFIER)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eNVELOPE_IDENTIFIER, true), gettype($eNVELOPE_IDENTIFIER)), __LINE__);
        }
        $this->ENVELOPE_IDENTIFIER = $eNVELOPE_IDENTIFIER;
        return $this;
    }
    /**
     * Get GTB_REFNO value
     * @return string|null
     */
    public function getGTB_REFNO()
    {
        return $this->GTB_REFNO;
    }
    /**
     * Set GTB_REFNO value
     * @param string $gTB_REFNO
     * @return \StructType\INVOICE_STATUS
     */
    public function setGTB_REFNO($gTB_REFNO = null)
    {
        // validation for constraint: string
        if (!is_null($gTB_REFNO) && !is_string($gTB_REFNO)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gTB_REFNO, true), gettype($gTB_REFNO)), __LINE__);
        }
        $this->GTB_REFNO = $gTB_REFNO;
        return $this;
    }
    /**
     * Get GTB_GCB_TESCILNO value
     * @return string|null
     */
    public function getGTB_GCB_TESCILNO()
    {
        return $this->GTB_GCB_TESCILNO;
    }
    /**
     * Set GTB_GCB_TESCILNO value
     * @param string $gTB_GCB_TESCILNO
     * @return \StructType\INVOICE_STATUS
     */
    public function setGTB_GCB_TESCILNO($gTB_GCB_TESCILNO = null)
    {
        // validation for constraint: string
        if (!is_null($gTB_GCB_TESCILNO) && !is_string($gTB_GCB_TESCILNO)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gTB_GCB_TESCILNO, true), gettype($gTB_GCB_TESCILNO)), __LINE__);
        }
        $this->GTB_GCB_TESCILNO = $gTB_GCB_TESCILNO;
        return $this;
    }
    /**
     * Get GTB_FIILI_IHRACAT_TARIHI value
     * @return string|null
     */
    public function getGTB_FIILI_IHRACAT_TARIHI()
    {
        return $this->GTB_FIILI_IHRACAT_TARIHI;
    }
    /**
     * Set GTB_FIILI_IHRACAT_TARIHI value
     * @param string $gTB_FIILI_IHRACAT_TARIHI
     * @return \StructType\INVOICE_STATUS
     */
    public function setGTB_FIILI_IHRACAT_TARIHI($gTB_FIILI_IHRACAT_TARIHI = null)
    {
        // validation for constraint: string
        if (!is_null($gTB_FIILI_IHRACAT_TARIHI) && !is_string($gTB_FIILI_IHRACAT_TARIHI)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gTB_FIILI_IHRACAT_TARIHI, true), gettype($gTB_FIILI_IHRACAT_TARIHI)), __LINE__);
        }
        $this->GTB_FIILI_IHRACAT_TARIHI = $gTB_FIILI_IHRACAT_TARIHI;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\INVOICE_STATUS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
