<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrepareInvoiceResponseResponse StructType
 * Meta information extracted from the WSDL
 * - type: PrepareInvoiceResponseResponse
 * @subpackage Structs
 */
class PrepareInvoiceResponseResponse extends AbstractStructBase
{
    /**
     * The APPRESPONSE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\Base64Binary[]
     */
    public $APPRESPONSE;
    /**
     * Constructor method for PrepareInvoiceResponseResponse
     * @uses PrepareInvoiceResponseResponse::setAPPRESPONSE()
     * @param \StructType\Base64Binary[] $aPPRESPONSE
     */
    public function __construct(array $aPPRESPONSE = array())
    {
        $this
            ->setAPPRESPONSE($aPPRESPONSE);
    }
    /**
     * Get APPRESPONSE value
     * @return \StructType\Base64Binary[]
     */
    public function getAPPRESPONSE()
    {
        return $this->APPRESPONSE;
    }
    /**
     * This method is responsible for validating the values passed to the setAPPRESPONSE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAPPRESPONSE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAPPRESPONSEForArrayConstraintsFromSetAPPRESPONSE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $prepareInvoiceResponseResponseAPPRESPONSEItem) {
            // validation for constraint: itemType
            if (!$prepareInvoiceResponseResponseAPPRESPONSEItem instanceof \StructType\Base64Binary) {
                $invalidValues[] = is_object($prepareInvoiceResponseResponseAPPRESPONSEItem) ? get_class($prepareInvoiceResponseResponseAPPRESPONSEItem) : sprintf('%s(%s)', gettype($prepareInvoiceResponseResponseAPPRESPONSEItem), var_export($prepareInvoiceResponseResponseAPPRESPONSEItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The APPRESPONSE property can only contain items of type \StructType\Base64Binary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set APPRESPONSE value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary[] $aPPRESPONSE
     * @return \StructType\PrepareInvoiceResponseResponse
     */
    public function setAPPRESPONSE(array $aPPRESPONSE = array())
    {
        // validation for constraint: array
        if ('' !== ($aPPRESPONSEArrayErrorMessage = self::validateAPPRESPONSEForArrayConstraintsFromSetAPPRESPONSE($aPPRESPONSE))) {
            throw new \InvalidArgumentException($aPPRESPONSEArrayErrorMessage, __LINE__);
        }
        $this->APPRESPONSE = $aPPRESPONSE;
        return $this;
    }
    /**
     * Add item to APPRESPONSE value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary $item
     * @return \StructType\PrepareInvoiceResponseResponse
     */
    public function addToAPPRESPONSE(\StructType\Base64Binary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Base64Binary) {
            throw new \InvalidArgumentException(sprintf('The APPRESPONSE property can only contain items of type \StructType\Base64Binary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->APPRESPONSE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PrepareInvoiceResponseResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
