<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserRequest StructType
 * @subpackage Structs
 */
class UserRequest extends REQUEST
{
    /**
     * The USERCONTENT
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\USERCONTENT[]
     */
    public $USERCONTENT;
    /**
     * Constructor method for UserRequest
     * @uses UserRequest::setUSERCONTENT()
     * @param \StructType\USERCONTENT[] $uSERCONTENT
     */
    public function __construct(array $uSERCONTENT = array())
    {
        $this
            ->setUSERCONTENT($uSERCONTENT);
    }
    /**
     * Get USERCONTENT value
     * @return \StructType\USERCONTENT[]
     */
    public function getUSERCONTENT()
    {
        return $this->USERCONTENT;
    }
    /**
     * This method is responsible for validating the values passed to the setUSERCONTENT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUSERCONTENT method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUSERCONTENTForArrayConstraintsFromSetUSERCONTENT(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $userRequestUSERCONTENTItem) {
            // validation for constraint: itemType
            if (!$userRequestUSERCONTENTItem instanceof \StructType\USERCONTENT) {
                $invalidValues[] = is_object($userRequestUSERCONTENTItem) ? get_class($userRequestUSERCONTENTItem) : sprintf('%s(%s)', gettype($userRequestUSERCONTENTItem), var_export($userRequestUSERCONTENTItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The USERCONTENT property can only contain items of type \StructType\USERCONTENT, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set USERCONTENT value
     * @throws \InvalidArgumentException
     * @param \StructType\USERCONTENT[] $uSERCONTENT
     * @return \StructType\UserRequest
     */
    public function setUSERCONTENT(array $uSERCONTENT = array())
    {
        // validation for constraint: array
        if ('' !== ($uSERCONTENTArrayErrorMessage = self::validateUSERCONTENTForArrayConstraintsFromSetUSERCONTENT($uSERCONTENT))) {
            throw new \InvalidArgumentException($uSERCONTENTArrayErrorMessage, __LINE__);
        }
        $this->USERCONTENT = $uSERCONTENT;
        return $this;
    }
    /**
     * Add item to USERCONTENT value
     * @throws \InvalidArgumentException
     * @param \StructType\USERCONTENT $item
     * @return \StructType\UserRequest
     */
    public function addToUSERCONTENT(\StructType\USERCONTENT $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\USERCONTENT) {
            throw new \InvalidArgumentException(sprintf('The USERCONTENT property can only contain items of type \StructType\USERCONTENT, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->USERCONTENT[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UserRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
